#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <sys/stat.h>
#include <ctype.h>

///****************************************
int main(int argc, char **argv) {

	int				i, fp, len, fi, bpl, adigs;
	unsigned char	*fbuf, *p, *s;
	char			buf[140], c;

	if( argc==3 ) {
		bpl = atoi(argv[1]);
		if( bpl<0 ) bpl = 1;
		if( bpl>128 ) bpl = 128;
		fi  = 2;
	} else if( argc==2 ) {
		bpl = 8;
		fi  = 1;
	} else {
		printf("usage: OCTDUMP <bytes/line> <filename>\r\n\
e.g.: OCTDUMP 8 BUNK.bin\r\n\
  or: OCTDUMP 16 BUNK.bin\r\n\
  or however many bytes you want dumped on each line of output\r\n\
  bytes/line must be from 1 to 128 (decimal values)");
		exit(1);
	}
	if( -1==(fp=open(argv[fi], _O_BINARY | _O_RDONLY)) ) {
		printf("Unable to open file: %s\r\n", argv[fi]);
		exit(-1);
	}
	len = _lseek(fp, 0, SEEK_END);
	_lseek(fp, 0, SEEK_SET);

	fbuf = (unsigned char*)malloc(len);

	len = read(fp, fbuf, len);
	close(fp);

	// figure out how many octal digits we need for the address
	for(adigs=1, i=len; (i>>=3); ) ++adigs;

	// okay, we're ready to dump 'em
	p = fbuf;
	while( (p-fbuf)<len ) {
		s = p;
		printf("%*.*o", adigs,adigs,(p-fbuf));
		for(i=0; (p-fbuf)<len && i<bpl; i++) {
			if( i==0 ) c = ':';
			else if( !(i & 7) ) c = '-';
			else c = ' ';
			printf("%c%3.3o", c, *p++);
		}
		// now dump any ASCII chars at EOL
		buf[0] = ' ';
		for(i=1; (s-fbuf)<len && i<=bpl; i++) {
			c = *s++;
			if( c<32 || c>126 ) c = '.';
			buf[i] = c;
		}
//		buf[i++] = '\r';
		buf[i++] = '\n';
		buf[i  ] = 0;
		printf(buf);
	}

	free(fbuf);
    exit(0);
}
